import type { USchema, MagicSuffix, DB_TYPE, UDateOptions, UNumericOptions, UStringOptions } from './types';
import type { TProperties, TPartial, TObject, StringFormatOption } from '@sinclair/typebox';
export declare const NONE_PARAM: Set<"Min" | "MinThan" | "Max" | "MaxThan" | "MinH" | "MinD" | "MinM" | "MaxH" | "MaxD" | "MaxM" | "Like" | "Likel" | "Liker" | "Bt" | "BtD" | "BtY" | "BtM" | "Not" | "IsNull" | "NotNull" | ">" | ">=" | "<" | "<=" | "=" | "!=" | "<>" | "In" | "NotIn">;
export type Settings = {
    provider: [DB_TYPE, () => any] | (() => any);
    pageSize?: number;
    /**
     * A log Function Example : default :null
     *      console.info
     *      logger.log
     */
    showSQL?: Function;
    strict?: boolean | {
        query?: boolean;
        entity?: boolean;
    };
};
export declare var ShowSql: any;
export declare var PAGE_SIZE: number;
export declare const setup: (settings: Settings) => void;
export declare const UType: {
    Table: <T extends TProperties>(properties: T) => TPartial<TObject<T>>;
    Number: (options?: UNumericOptions) => import("@sinclair/typebox").TNumber;
    String: <Format extends string>(options?: UStringOptions<StringFormatOption | Format>) => import("@sinclair/typebox").TString<Format>;
    Date: (options?: UDateOptions) => import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TDate, import("@sinclair/typebox").TString<string>, import("@sinclair/typebox").TNumber]>;
    Boolean: (options?: USchema) => import("@sinclair/typebox").TBoolean;
    Integer: (options?: UNumericOptions) => import("@sinclair/typebox").TInteger;
};
export declare const throwErr: (err: string[], message?: string) => void;
export declare const checkEntity: (T: TObject, val: any) => void;
export declare const betweenNumber: (txt: string, parseFn: any) => [MagicSuffix, number][];
export declare const betweenDate: (txt: string) => [MagicSuffix, Date][];
export declare const inString: (txt: string) => string[];
export declare const inNumber: (txt: string) => number[];
export declare const boolValue: (value: any) => boolean;
