"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = exports.Table = exports.FlatView = exports.View = exports.UType = void 0;
const lodash_1 = __importDefault(require("lodash"));
const elasticsearch_1 = require("@elastic/elasticsearch");
const Util_1 = require("../base/Util");
var Util_2 = require("../base/Util");
Object.defineProperty(exports, "UType", { enumerable: true, get: function () { return Util_2.UType; } });
var View_1 = require("./basic/View");
Object.defineProperty(exports, "View", { enumerable: true, get: function () { return View_1.View; } });
Object.defineProperty(exports, "FlatView", { enumerable: true, get: function () { return View_1.FlatView; } });
var Table_1 = require("./basic/Table");
Object.defineProperty(exports, "Table", { enumerable: true, get: function () { return Table_1.Table; } });
const setup = (settings) => {
    let client;
    if (lodash_1.default.isFunction(settings.provider)) {
        client = settings.provider();
    }
    else {
        client = new elasticsearch_1.Client(settings.provider);
    }
    (0, Util_1.setup)(Object.assign(Object.assign({}, settings), { provider: ['es', () => client] }));
    return client;
};
exports.setup = setup;
