"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executor = void 0;
const Util_1 = require("../../base/Util");
const log = (SQL, PARAM) => {
    if (Util_1.ShowSql == null)
        return;
    (0, Util_1.ShowSql)(`${SQL} | ${JSON.stringify(PARAM)}`);
};
exports.executor = {
    add: (pool, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const conn = yield pool.getConnection();
        try {
            const addResult = yield conn.query(SQL, PARAM);
            if (addResult[0] && addResult[0].affectedRows == 1) {
                const [lastResult] = yield conn.query(`SELECT LAST_INSERT_ID() as id;`);
                return lastResult[0];
            }
            throw new Error('Insert Error');
        }
        catch (e) {
            throw new Error(e);
        }
        finally {
            console.log('release');
            conn.release();
        }
    }),
    get: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const [rows] = yield conn.query(SQL, PARAM);
        if (rows.length > 0)
            return rows[0];
        return null;
    }),
    query: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const [rows] = yield conn.query(SQL, PARAM);
        return rows;
    }),
    execute: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield conn.query(SQL, PARAM);
        return result[0].affectedRows;
    }),
};
