import type { Static, TObject } from '@sinclair/typebox';
import type { DB_TYPE } from '../base/types';
import type { PoolOptions, FieldPacket } from 'mysql2/promise';
import { Pool } from 'mysql2/promise';
import { Settings } from '../base/Util';
import { SqlBuilder, SqlExecutor } from '../base/sql';
import { BaseView, TableOptions } from '../base/BaseView';
import { BaseTable } from '../base/BaseTable';
export { UType } from '../base/Util';
export type { WhereParam, WhereCondition, WhereItem, QuerySchema, MagicSuffix, } from '../base/types';
export type { Static } from '@sinclair/typebox';
export declare class View<T extends TObject> extends BaseView<T, Pool> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<T>;
    protected init(schema: T, options?: TableOptions): void;
    /**
     * same arguments as mysql.query()
     * */
    exec(...args: any[]): Promise<[any, FieldPacket[]]>;
}
export declare class Table<T extends TObject> extends BaseTable<T, Pool> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<T>;
    protected init(schema: T, options?: TableOptions): void;
    add(object: Static<T>): Promise<Static<T>>;
    /**
     * same arguments as mysql.query()
     * */
    exec(...args: any[]): Promise<[any, FieldPacket[]]>;
}
export type MYSettings = Omit<Settings, 'provider'> & {
    provider: PoolOptions | (() => Pool);
};
export declare const setup: (settings: MYSettings, cb?: (err: Error) => void) => Pool;
