"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executor = void 0;
const Util_1 = require("../../base/Util");
const log = (SQL, PARAM) => {
    if (Util_1.ShowSql == null)
        return;
    (0, Util_1.ShowSql)(`${SQL} | ${JSON.stringify(PARAM)}`);
};
exports.executor = {
    add: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield conn.query(SQL, PARAM);
        if (result.rowCount == 1)
            return result.rows[0];
        throw new Error();
    }),
    get: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield conn.query(SQL, PARAM);
        if (result.rowCount > 0)
            return result.rows[0];
        return null;
    }),
    query: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield conn.query(SQL, PARAM);
        return result.rows;
    }),
    execute: (conn, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield conn.query(SQL, PARAM);
        return result.rowCount;
    }),
};
